

           #include <P16F628A.INC>
            LIST        p=16F628A    ; 
            __CONFIG    H'3F10'      ;  
                                    ; 
            
Sec         equ         20h  ;
Sec0        equ         21h   ; 
Sec1        equ         22h   ;
scetbit     equ         23h   ;
perem       equ         24h    ;
vivH        equ         25h
vivL        equ         26h    ;
viv2        equ         27h    ;
fsradr      equ         28h    ;
Sec2        equ         29h      ;
result      equ         2Ah     ; 
figur       equ         2Bh       ;
smehen      equ         2Ch
nomer       equ         2Dh     ;
perem1      equ         2Eh
shetson     equ         2Fh
slpshet     equ         30h



flag        equ         007Ch
adres       equ         007Dh
W_temp      equ         007Eh
STATUS_temp equ         007Fh





data1       equ         00E7h



#DEFINE     kn1  	PORTB,4
#DEFINE     kn2 	PORTA,6
#DEFINE     red  	PORTB,6
#DEFINE     grn 	PORTB,7

#DEFINE     clk   	PORTA,0
#DEFINE     data  	PORTB,3
#DEFINE     res  	PORTA,7
#DEFINE     cs  	PORTB,5



            org         0000h                         ;      0 PC.
            goto        Start 


            org         0004h          
            
            

prer        movwf       W_temp          ;  STATUS  W
            swapf       STATUS,W          
            movwf       STATUS_temp
             
       
            btfss       flag,7
            goto        slep
a1          movf        adres,W
            movwf       FSR
            btfsc       flag,1    ; ./. 1-., 0-.
            goto        aa1
            bsf         flag,1
            btfsc       flag,0    ; ./. 1-., 0-
            goto        aa2
            movlw       .2        ; 
            movwf       INDF
            goto        aa3
aa2         movlw       .1        ; 
            movwf       INDF
aa3         call        vivod
            goto        ext

aa1         bcf         flag,1
            clrf        INDF
            call        vivod    ;   


                     
ext         bcf         T1CON,TMR1ON   ; TMR1
            bcf         PIR1,TMR1IF    ;  
            clrf        TMR1L          ; 
            clrf        TMR1H
            bsf         T1CON,TMR1ON   ; TMR1

            decfsz      shetson,F
            goto        exxit
            movlw       .2
            movwf       shetson
            incf        slpshet,F 
            
            
exxit       swapf       STATUS_temp,W   ;  STATUS  W
            movwf       STATUS
            swapf       W_temp,F
            swapf       W_temp,W
            retfie                      ;   

            
slep        bcf         PIR1,TMR1IF
            decfsz      shetson,F
            goto        exxit
            movlw       .2
            movwf       shetson
            incf        slpshet,F  
            goto        exxit  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

           
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 

Start       movlw       b'00000000'
            movwf       PORTB
            movlw       b'00000001'
            movwf       PORTA
            movlw       b'00000111'
            movwf       CMCON

            bsf         STATUS,RP0        
            movlw       b'00010111'          
            movwf       TRISB
            movlw       b'11111110'          
            movwf       TRISA
            bsf         PIE1,TMR1IE    ;. .  TMR1
            bcf         STATUS,RP0

            movlw       b'00110000'          
            movwf       T1CON
            bcf         PIR1,TMR1IF     ;    TMR1
            bsf         INTCON,PEIE      ; .  . 
            bsf         INTCON,GIE
            clrf        TMR1L
            clrf        TMR1H
          
            clrf        nomer

            bsf          STATUS,RP0
            movlw        b'11010111'
            movwf        OPTION_REG
            bcf          STATUS,RP0
           
            movlw        .2
            movwf        shetson
            bcf          flag,7
            bsf          T1CON,TMR1ON
            goto        auto
           
twoigrok    call        clean   
            movlw       b'01000000'    ;   , 2 
            movwf       vivH
            movlw       b'11000100'
            movwf       vivL
            movlw       b'00000010'
            movwf       viv2
            call        b10
      

cc1         call        pausknp   ;   1  2
            btfss       kn1
            goto        cc1
            btfss       kn2
            goto        cc1

q01         movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         cc2
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RBIF
            bsf          INTCON,RBIE
            SLEEP
            bcf          INTCON,RBIE
            bsf          INTCON,GIE
            call         b10
mk1         call         pausknp
            btfss        kn1
            goto         mk1
            
cc2         btfss      kn1        ;  1  2 
            goto       cc3
            btfss      kn2
            goto       cc4
            call       pausknp
            goto       q01

cc3         btfsc      kn1        ; 1 
            goto       kr
            btfss      kn2
            goto       kn12
            call       pausknp
            goto       cc3

            
cc4         btfsc      kn2         ; 2 
            goto       nolik
            btfss      kn1
            goto       kn12
            call       pausknp
            goto       cc4

kn12        movlw      .30
            movwf      Sec2
cc5         call       pausknp
            btfsc      kn1         ;   
            goto       kr
            btfsc      kn2
            goto       nolik
            decfsz     Sec2,F
            goto       cc5
            goto       auto


kr          call        clean
            goto        vizkr
nolik       call        clean
            goto        viznol

opkn1       movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         kj1
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RBIF
            bsf          INTCON,RBIE
            SLEEP
            bcf          INTCON,RBIE
            bsf          INTCON,GIE
            call         b10
mk2         call         pausknp
            btfss        kn1
            goto         mk2
kj1         call       pausknp
            btfsc      kn1
            goto       opkn1
vizkr       call       krest
            call       rezult
 
            movlw       .1
            subwf       result,W
            btfss       STATUS,Z
            goto        g1
            call        pause
            call        clean

            movlw       data1     ;   
            movwf       FSR
            movlw       .5
            movwf       perem
gg1         movlw       .1
            movwf       INDF
            movlw       .2
            addwf       FSR,F
            decfsz      perem,F
            goto        gg1
            call        vivod
            goto        cc1


opkn2       movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         kj2
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RBIF
            bsf          INTCON,RBIE
            SLEEP
            bcf          INTCON,RBIE
            bsf          INTCON,GIE
            call         b10
mk5         call         pausknp
            btfss        kn1
            goto         mk5
kj2        call       pausknp
            btfsc      kn2
            goto       opkn2
viznol      call       nol
            call       rezult
 
            movlw       .0
            subwf       result,W
            btfss       STATUS,Z
            goto        g2
            call        pause
            call        clean

               
            movlw       b'10100101'   ;   
            movwf       vivH
            movlw       b'00011010'
            movwf       vivL
            movlw       b'00000001'
            movwf       viv2
            call        b10
            goto        cc1



g1          movlw       .2
            subwf       result,W
            btfss       STATUS,Z
            goto        opkn2
            call        pause
            call        clean

nic         movlw       b'10011111'
            movwf       vivH
            movlw       b'11110011'
            movwf       vivL
            movlw       b'00000011'
            movwf       viv2
            call        b10
            goto        cc1

g2          movlw       .2
            subwf       result,W
            btfss       STATUS,Z
            goto        opkn1
            call        pause
            call        clean
            goto        nic
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

auto        call        clean     ;   ,  
            movlw       b'00110001'
            movwf       vivH
            movlw       b'00001000'
            movwf       vivL
            movlw       b'00000001'
            movwf       viv2
            call        b10
            bsf         flag,2    ;  
            bcf         flag,3    ;   
      

kk1         clrf         slpshet
            call        pausknp   ;   1  2
           ; goto        nach  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
            btfss       kn1
            goto        kk1
            btfss       kn2
            goto        kk1
      
            

q02         movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         kk2
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RBIF
            bsf          INTCON,RBIE
            SLEEP
            bcf          INTCON,RBIE
            bsf          INTCON,GIE
            call         b10
mk3         call         pausknp
            btfss        kn1
            goto         mk3

kk2         btfss      kn1        ;  1 
            goto       kk3
            call       pausknp
            goto       q02

kk3         btfsc      kn1        ; 1 
            goto       nach
            btfss      kn2
            goto       knk12
            call       pausknp
            goto       kk3

      

knk12       movlw      .30
            movwf      Sec2
kk5         call       pausknp
            btfsc      kn1         ;   
            goto       nach
            btfsc      kn2
            goto       kk1
            decfsz     Sec2,F
            goto       kk5
            goto       twoigrok

nach        call       clean
            call       vivod
            btfss      flag,2
            goto       comp
            bcf        flag,2
            goto       vizkr1



opkn11      clrf       slpshet 
            call       pausknp
            btfss      kn1
            goto       opkn11
opkn111     movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         kj3
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RBIF
            bsf          INTCON,RBIE
            SLEEP
            bcf          INTCON,RBIE
            bsf          INTCON,GIE
            call         b10
mk4         call         pausknp
            btfss        kn1
            goto         mk4
kj3         call       pausknp
            btfsc      kn1
            goto       opkn111
vizkr1      call       krest
            call       rezult

            movlw       .1
            subwf       result,W
            btfss       STATUS,Z
            goto        m1
            call        pause
            call        clean

            movlw       b'00001010'    ;   
            movwf       vivH
            movlw       b'01100001'
            movwf       vivL
            movlw       b'00000000'
            movwf       viv2
            call        b10
            goto        kk1


m1          movlw       .2
            subwf       result,W
            btfss       STATUS,Z
            goto        hodcomp
            call        pause
            call        clean

nic1        movlw       b'10011111'    ;   ,  
            movwf       vivH
            movlw       b'11110011'
            movwf       vivL
            movlw       b'00000011'
            movwf       viv2
            call        b10
            goto        kk1

comp        bsf         flag,3
            bsf         flag,2
hodcomp     movlw       .3
            call        paus
            call        hodcmp
            call        vivod
            call       rezult
 
            movlw       .0
            subwf       result,W
            btfss       STATUS,Z
            goto        m2
            call        pause
            call        clean

            movlw       b'10100101'   ;   
            movwf       vivH
            movlw       b'00011010'
            movwf       vivL
            movlw       b'00000001'
            movwf       viv2
            call        b10
            goto        kk1


m2          movlw       .2
            subwf       result,W
            btfss       STATUS,Z
            goto        opkn11
            call        pause
            call        clean
            goto        nic1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

hodcmp      movlw       data1    ;  
            movwf       FSR
            movlw       .9
            movwf       perem
na1         movlw       .0
            subwf       INDF,W
            btfsc       STATUS,Z
            goto        nn1
nn2         incf        FSR,F
            decfsz      perem,F
            goto        na1
            goto        n1
nn1         movf        FSR,W
            movwf       fsradr
            movf        INDF,W
            movwf       figur
            movlw       .2
            movwf       INDF
            call        rezult
            movlw       .0
            subwf       result,F
            btfsc       STATUS,Z
            goto        na2
            movf        fsradr,W
            movwf       FSR
            movf        figur,W
            movwf       INDF
            goto        nn2
na2         movf        fsradr,W
            movwf       FSR
            movlw       .2
            movwf       INDF
            return

n1          movlw       data1    ;  
            movwf       FSR
            movlw       .9
            movwf       perem
nb1         movlw       .0
            subwf       INDF,W
            btfsc       STATUS,Z
            goto        nb2
nb4         incf        FSR,F
            decfsz      perem,F
            goto        nb1
            goto        n2
nb2         movf        FSR,W
            movwf       fsradr
            movf        INDF,W
            movwf       figur
            movlw       .1
            movwf       INDF
            call        rezult
            movlw       .1
            subwf       result,F
            btfsc       STATUS,Z
            goto        nb3
            movf        fsradr,W
            movwf       FSR
            movf        figur,W
            movwf       INDF
            goto        nb4
nb3         movf        fsradr,W
            movwf       FSR
            movlw       .2
            movwf       INDF
            return

n2          movlw       data1    ;  
            movwf       FSR
            movlw       .1
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nc1
            movlw       .8
            addwf       FSR,F
            movlw       .1
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nc1
            goto        nd1
nc1         movlw       data1    
            movwf       FSR
            incf        FSR,F
            incf        FSR,F
            movlw       .1
            subwf       INDF,W
            btfss       STATUS,Z
            goto        n3
            movlw       .4
            addwf       FSR,F
            movlw       .1
            subwf       INDF,W
            btfss       STATUS,Z
            goto        n3
nd1         movlw       data1    
            movwf       FSR
            incf        FSR,F
            movlw       .4
            movwf       perem
nd2         movlw       .0
            subwf       INDF,W
            btfsc       STATUS,Z
            goto        nd3
            movlw       .2       
            addwf       FSR,F
            decfsz      perem,F
            goto        nd2
            goto        n3

nd3         movlw       .2    
            movwf       INDF
            return

n3          movlw       data1    ; 
            movwf       FSR
            movlw       .9
            movwf       perem
ne1         movlw       .0
            subwf       INDF,W
            btfsc       STATUS,Z
            goto        ne3
ne2         incf        FSR,F
            decfsz      perem,F
            goto        ne1
            goto        n4
ne3         movf        FSR,W
            movwf       fsradr
            movf        INDF,W
            movwf       figur
            movlw       .2
            movwf       INDF
            call        rezult
            movlw       .2
            subwf       result,F
            btfsc       STATUS,Z
            goto        ne4
            movf        fsradr,W
            movwf       FSR
            movf        figur,W
            movwf       INDF
            goto        ne2
ne4         movf        fsradr,W
            movwf       FSR
            movlw       .2
            movwf       INDF
            return

n4          movlw       data1    ;    
            movwf       FSR
            movlw       .2
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nf1
            movlw       .8
            addwf       FSR,F
            movlw       .0
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nf1
            movlw       .2
            movwf       INDF
            return

nf1         movlw       data1    
            movwf       FSR
            incf        FSR,F
            incf        FSR,F
            movlw       .2
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nf2
            movlw       .4
            addwf       FSR,F
            movlw       .0
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nf2
            movlw       .2
            movwf       INDF
            return

nf2         movlw       data1    
            movwf       FSR
            movlw       .8
            addwf       FSR,F
            movlw       .2
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nf3
            movlw       .8
            subwf       FSR,F
            movlw       .0
            subwf       INDF,W
            btfss       STATUS,Z
            goto        nf3
            movlw       .2
            movwf       INDF
            return




nf3         movlw       data1    
            movwf       FSR
            movlw       .6
            addwf       FSR,F
            movlw       .2
            subwf       INDF,W
            btfss       STATUS,Z
            goto        n5
            movlw       .4
            subwf       FSR,F
            movlw       .0
            subwf       INDF,W
            btfss       STATUS,Z
            goto        n5
            movlw       .2
            movwf       INDF
            return
 
n5          btfss        flag,3
            goto         nk1
            bcf          flag,3
            movlw        data1    
            movwf        FSR
            movf         TMR0,W
            movwf        smehen
            movlw        b'00001111'
            andwf        smehen,F
            call         table
            addwf        FSR,F
            movlw        .2
            movwf        INDF
            return



nk1         movlw        data1    
            movwf        FSR
            movf         nomer,W
            movwf        smehen
            call         table1
            addwf        FSR,F
            movlw        .0
            subwf        INDF,W
            btfss        STATUS,Z
            goto         nk2
            movlw        .2
            movwf        INDF
            return
nk2         incf         nomer,F
            movlw        .16
            subwf        nomer,W
            btfss        STATUS,Z
            goto         nk1
            clrf         nomer
            goto         nk1
            




table       movlw       high data0
            movwf       PCLATH
            movf        smehen,W
            addlw       low data0
            btfsc       STATUS,C
            incf        PCLATH,F
            movf        smehen,W
            addwf       PCL,F
data0       dt 0x00, 0x04, 0x07
            dt 0x02, 0x08, 0x03
            dt 0x06, 0x00, 0x01
            dt 0x04, 0x08, 0x05
            dt 0x02, 0x06, 0x00
            dt 0x04

table1      movlw       high data2
            movwf       PCLATH
            movf        smehen,W
            addlw       low data2
            btfsc       STATUS,C
            incf        PCLATH,F
            movf        smehen,W
            addwf       PCL,F
data2       dt 0x04, 0x02, 0x07
            dt 0x05, 0x06, 0x03
            dt 0x00, 0x08, 0x01
            dt 0x07, 0x03, 0x04
            dt 0x02, 0x06, 0x00
            dt 0x05
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

rezult     movlw       data1
           movwf       FSR
           movlw       .3
           movwf       perem1
ff1        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f2
           incf        FSR,F
           decfsz      perem1,F
           goto        ff1
           goto        krwin

f2         movlw       data1
           movwf       FSR
           movlw       .3
           addwf       FSR,F
           movlw       .3
           movwf       perem1
ff2        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f3
           incf        FSR,F
           decfsz      perem1,F
           goto        ff2
           goto        krwin

f3         movlw       data1
           movwf       FSR
           movlw       .6
           addwf       FSR,F
           movlw       .3
           movwf       perem1
ff3        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f4
           incf        FSR,F
           decfsz      perem1,F
           goto        ff3
           goto        krwin

f4         movlw       data1
           movwf       FSR
           movlw       .3
           movwf       perem1
ff4        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f5
           movlw       .3
           addwf       FSR,F
           decfsz      perem1,F
           goto        ff4
           goto        krwin

f5         movlw       data1
           movwf       FSR
           incf        FSR,F
           movlw       .3
           movwf       perem1
ff5        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f6
           movlw       .3
           addwf       FSR,F
           decfsz      perem1,F
           goto        ff5
           goto        krwin

f6         movlw       data1
           movwf       FSR
           incf        FSR,F
           incf        FSR,F
           movlw       .3
           movwf       perem1
ff6        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f7
           movlw       .3
           addwf       FSR,F
           decfsz      perem1,F
           goto        ff6
           goto        krwin

f7         movlw       data1
           movwf       FSR
           movlw       .3
           movwf       perem1
ff7        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f8
           movlw       .4
           addwf       FSR,F
           decfsz      perem1,F
           goto        ff7
           goto        krwin

f8         movlw       data1
           movwf       FSR
           incf        FSR,F
           incf        FSR,F
           movlw       .3
           movwf       perem1
ff8        movlw       .1
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f11
           movlw       .2
           addwf       FSR,F
           decfsz      perem1,F
           goto        ff8
           goto        krwin

f11        movlw       data1
           movwf       FSR
           movlw       .3
           movwf       perem1
fa1        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f12
           incf        FSR,F
           decfsz      perem1,F
           goto        fa1
           goto        nolwin

f12        movlw       data1
           movwf       FSR
           movlw       .3
           addwf       FSR,F
           movlw       .3
           movwf       perem1
fa2        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f13
           incf        FSR,F
           decfsz      perem1,F
           goto        fa2
           goto        nolwin

f13        movlw       data1
           movwf       FSR
           movlw       .6
           addwf       FSR,F
           movlw       .3
           movwf       perem1
fa3        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f14
           incf        FSR,F
           decfsz      perem1,F
           goto        fa3
           goto        nolwin

f14        movlw       data1
           movwf       FSR
           movlw       .3
           movwf       perem1
fa4        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f15
           movlw       .3
           addwf       FSR,F
           decfsz      perem1,F
           goto        fa4
           goto        nolwin

f15        movlw       data1
           movwf       FSR
           incf        FSR,F
           movlw       .3
           movwf       perem1
fa5        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f16
           movlw       .3
           addwf       FSR,F
           decfsz      perem1,F
           goto        fa5
           goto        nolwin

f16        movlw       data1
           movwf       FSR
           incf        FSR,F
           incf        FSR,F
           movlw       .3
           movwf       perem1
fa6        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f17
           movlw       .3
           addwf       FSR,F
           decfsz      perem1,F
           goto        fa6
           goto        nolwin

f17        movlw       data1
           movwf       FSR
           movlw       .3
           movwf       perem1
fa7        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        f18
           movlw       .4
           addwf       FSR,F
           decfsz      perem1,F
           goto        fa7
           goto        nolwin

f18        movlw       data1
           movwf       FSR
           incf        FSR,F
           incf        FSR,F
           movlw       .3
           movwf       perem1
fa8        movlw       .2
           subwf       INDF,W
           btfss       STATUS,Z
           goto        fb1
           movlw       .2
           addwf       FSR,F
           decfsz      perem1,F
           goto        fa8
           goto        nolwin

fb1        movlw       data1
           movwf       FSR
           movlw       .9
           movwf       perem1
fb2        movlw       .0
           subwf       INDF,W
           btfsc       STATUS,Z
           goto        prodol
           incf        FSR,F
           decfsz      perem1,F
           goto        fb2
           movlw       .2
           movwf       result
           return

prodol     movlw       .3
           movwf       result
           return

krwin      movlw       .1
           movwf       result
           return

nolwin     movlw       .0
           movwf       result
           return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

nol         bcf        flag,0
e3          movlw      0xEF
            movwf      FSR
e2          movlw      .0
            subwf      INDF,W
            btfsc      STATUS,Z
            goto       e1
e8          decf       FSR,F
            movlw      0xE6
            subwf      FSR,W
            btfss      STATUS,Z
            goto       e2
            goto       e3
e1          movlw      .2
            movwf      INDF
            movf       FSR,W
            movwf      adres
            call       vivod
            bsf        flag,1
            bcf        T1CON,TMR1ON
            bcf         PIR1,TMR1IF     ;    TMR1
            clrf        TMR1L
            clrf        TMR1H
            bsf        flag,7
            bsf         T1CON,TMR1ON
            
          
e4          call       pausknp
            btfss      kn2
            goto       e4
e5          movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         ee5
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RBIF
            bsf          INTCON,RBIE
            SLEEP
            bcf          INTCON,RBIE
            bsf          INTCON,GIE
            call         b10
mk18        call         pausknp
            btfss        kn1
            goto         mk18
ee5         call       pausknp
            btfsc      kn2
            goto       e5
            movlw      .30
            movwf      Sec2
e7          call       pausknp
            btfsc      kn2
            goto       e6
            decfsz     Sec2,F
            goto       e7
            bcf        T1CON,TMR1ON
            bcf         PIR1,TMR1IF     ;    TMR1
            clrf        TMR1L
            clrf        TMR1H 
            movlw      .2
            movwf      shetson
            bcf        flag,7
            bsf         T1CON,TMR1ON
            movf       adres,W
            movwf      FSR
            movlw      .2
            movwf      INDF
            call       vivod
            return
e6          bcf        T1CON,TMR1ON
            bcf         PIR1,TMR1IF     ;    TMR1
            clrf        TMR1L
            clrf        TMR1H 
            movlw      .2
            movwf      shetson
            bcf        flag,7
            bsf         T1CON,TMR1ON
            movf       adres,W
            movwf      FSR
            movlw      .0
            movwf      INDF
            goto       e8

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


krest       bsf        flag,0
d3          movlw      data1
            movwf      FSR
d2          movlw      .0
            subwf      INDF,W
            btfsc      STATUS,Z
            goto       d1
d8          incf       FSR,F
            movlw      0xF0
            subwf      FSR,W
            btfss      STATUS,Z
            goto       d2
            goto       d3
d1          movlw      .1
            movwf      INDF
            movf       FSR,W
            movwf      adres
            call       vivod
            bsf        flag,1
            bcf        T1CON,TMR1ON
            bcf         PIR1,TMR1IF     ;    TMR1
            clrf        TMR1L
            clrf        TMR1H 
            bsf        flag,7
            bsf         T1CON,TMR1ON
         
d4          call       pausknp
            btfss      kn1
            goto       d4
d5          movf         slpshet,W
            sublw        .240
            btfsc        STATUS,C
            goto         dd5
            bcf          INTCON,GIE
            call         offreg
            clrf         slpshet
            bcf          INTCON,RBIF
            bsf          INTCON,RBIE
            SLEEP
            bcf          INTCON,RBIE
            bsf          INTCON,GIE
            call         b10
mk19        call         pausknp
            btfss        kn1
            goto         mk19
dd5         call       pausknp
            btfsc      kn1
            goto       d5
            movlw      .30
            movwf      Sec2
d7          call       pausknp
            btfsc      kn1
            goto       d6
            decfsz     Sec2,F
            goto       d7
             bcf        T1CON,TMR1ON
            bcf         PIR1,TMR1IF     ;    TMR1
            clrf        TMR1L
            clrf        TMR1H 
            movlw      .2
            movwf      shetson
            bcf        flag,7
            bsf         T1CON,TMR1ON
            movf       adres,W
            movwf      FSR
            movlw      .1
            movwf      INDF
            call       vivod
            return
d6          bcf        T1CON,TMR1ON
            bcf         PIR1,TMR1IF     ;    TMR1
            clrf        TMR1L
            clrf        TMR1H 
             movlw      .2
            movwf      shetson
            bcf        flag,7
            bsf         T1CON,TMR1ON
            movf       adres,W
            movwf      FSR
            movlw      .0
            movwf      INDF
            goto       d8


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


clean       movlw      data1
            movwf      FSR
            movlw      .9
            movwf      perem
c1          clrf       INDF
            incf       FSR,F
            decfsz     perem,F
            goto       c1
            return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



vivod        movlw      data1
             movwf      FSR
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bb1
             bcf        vivH,2
             bcf        vivH,3
             goto       b2
bb1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bb2
             bsf        vivH,3
             bcf        vivH,2
             goto       b2
bb2          bsf        vivH,2
             bcf        vivH,3


b2           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       ba1
             bcf        vivH,5
             bcf        vivH,6
             goto       b3
ba1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       ba2
             bsf        vivH,6
             bcf        vivH,5
             goto       b3
ba2          bsf        vivH,5
             bcf        vivH,6

b3           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bc1
             bcf        vivH,7
             bcf        vivH,1
             goto       b4
bc1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bc2
             bsf        vivH,1
             bcf        vivH,7
             goto       b4
bc2          bsf        vivH,7
             bcf        vivH,1

b4           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bd1
             bcf        viv2,0
             bcf        viv2,1
             goto       b5
bd1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bd2
             bsf        viv2,1
             bcf        viv2,0
             goto       b5
bd2          bsf        viv2,0
             bcf        viv2,1

b5           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       be1
             bcf        vivH,4
             bcf        vivL,6
             goto       b6
be1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       be2
             bsf        vivL,6
             bcf        vivH,4
             goto       b6
be2          bsf        vivH,4
             bcf        vivL,6

b6           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bf1
             bcf        vivH,0
             bcf        vivL,7
             goto       b7
bf1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bf2
             bsf        vivL,7
             bcf        vivH,0
             goto       b7
bf2          bsf        vivH,0
             bcf        vivL,7

b7           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bg1
             bcf        vivL,4
             bcf        vivL,5
             goto       b8
bg1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bg2
             bsf        vivL,5
             bcf        vivL,4
             goto       b8
bg2          bsf        vivL,4
             bcf        vivL,5

b8           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bi1
             bcf        vivL,3
             bcf        vivL,2
             goto       b9
bi1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bi2
             bsf        vivL,2
             bcf        vivL,3
             goto       b9
bi2          bsf        vivL,3
             bcf        vivL,2


b9           incf       FSR,F
             movlw      .0
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bj1
             bcf        vivL,1
             bcf        vivL,0
             goto       bb100
bj1          movlw      .1
             subwf      INDF,W
             btfss      STATUS,Z
             goto       bj2
             bsf        vivL,0
             bcf        vivL,1
             goto       bb100
bj2          bsf        vivL,1
             bcf        vivL,0



bb100        btfsc      flag,7
             goto       bb99
b10          clrf       slpshet
bb99         bcf        cs
             movlw      .8
             movwf      scetbit
             bsf        clk

povtor       btfsc      vivL,0
             bsf        data
             btfss      vivL,0
             bcf        data
             bcf        clk        
             bsf        clk
             rrf        vivL,F
             decfsz     scetbit,F
             goto       povtor
             rrf        vivL,F
           
             movlw      .8
             movwf      scetbit
povtor1      btfsc      vivH,0
             bsf        data
             btfss      vivH,0
             bcf        data
             bcf        clk
             bsf        clk
             rrf        vivH,F
             decfsz     scetbit,F
             goto       povtor1
             rrf        vivH,F

             btfsc      viv2,0
             bsf        red
             btfss      viv2,0
             bcf        red
             btfsc      viv2,1
             bsf        grn
             btfss      viv2,1
             bcf        grn
             bsf        cs
             return



offreg       bcf        cs
             movlw      .16
             movwf      scetbit
             bsf        clk
             bcf        data
ii01         bcf        clk
             bsf        clk
             decfsz     scetbit,F
             goto       ii01
             bcf        red
             bcf        grn
             bcf        clk
             return


pausknp        movlw     .40       ; 30
               movwf     Sec0
p2             movlw     .255
               movwf     Sec
p1             decfsz    Sec,F
               goto      p1
               decfsz    Sec0,F
               goto      p2
               return


pause        movlw       .10       ; 
paus         movwf       Sec0
pld3         movlw       .128
             movwf       Sec1           
pld2         movlw       .255
             movwf       Sec
pld1         decfsz      Sec,F
             goto        pld1
             decfsz      Sec1,F
             goto        pld2
             decfsz      Sec0,F
             goto        pld3
             return
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

            END


             







